
package net.ihe.gazelle.xdstar.epsos.ws;

/**
 * Please modify this class to meet your needs
 * This class is not complete
 */

import net.ihe.gazelle.query.AdhocQueryResponseType;
import net.ihe.gazelle.util.Pair;
import net.ihe.gazelle.xds.RetrieveDocumentSetRequestType;
import net.ihe.gazelle.xds.RetrieveDocumentSetResponseType;
import net.ihe.gazelle.xdstar.common.model.AbstractMessage;
import net.ihe.gazelle.xdstar.comon.util.XDSNamespacePrefixMapper;
import net.ihe.gazelle.xdstar.core.MessageSenderCommon;
import net.ihe.gazelle.xdstar.core.soap.SOAPRequestBuilder;
import net.ihe.gazelle.xdstar.validator.MetadataValidator;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.UnsupportedEncodingException;
import java.nio.charset.StandardCharsets;

import static org.apache.commons.lang.CharEncoding.UTF_8;

/**
 * This class was generated by Apache CXF 2.7.6
 * 2013-09-11T10:33:05.914+02:00
 * Generated source version: 2.7.6
 */
public final class RespondingGatewayRetrievePortTypeClient {

    private static final Logger LOG = LoggerFactory.getLogger(RespondingGatewayRetrievePortTypeClient.class);

    public Pair<String, String> send(RetrieveDocumentSetRequestType batchRequest, String wsdlLocation) throws Exception {
        MessageSenderCommon msc = new MessageSenderCommon();
        String messageToSend = this.getAdhocQueryAsString(batchRequest);
        if (messageToSend.contains("?>")) {
            messageToSend = messageToSend.substring(messageToSend.indexOf("?>") + 2);
        }
        messageToSend = SOAPRequestBuilder.createSOAPMessage(messageToSend, false, null, null, null,
                wsdlLocation, "urn:ihe:iti:2007:CrossGatewayRetrieve", false);
        AbstractMessage request = new AbstractMessage();
        Pair<String, String> res = msc.sendMessage(wsdlLocation,
                messageToSend.getBytes(StandardCharsets.UTF_8), request, "application/soap+xml", null);
        return res;

    }

    public AdhocQueryResponseType sendAndGetAdhocQueryResponse(RetrieveDocumentSetRequestType batchRequest, String wsdlLocation) throws Exception {
        Pair<String, String> res = this.send(batchRequest, wsdlLocation);
        try {
            res.setObject2(MetadataValidator.extractNode(res.getObject2(), "RetrieveDocumentSetResponse", "urn:ihe:iti:xds-b:2007"));
        } catch (Exception e) {
            LOG.error("" + e.getMessage());
        }
        AdhocQueryResponseType aqr = this.getRetrieveDocumentSetResponseeFromString(res.getObject2());
        return aqr;
    }

    protected AdhocQueryResponseType getRetrieveDocumentSetResponseeFromString(String aqr) {
        if (aqr != null) {
            try {
                JAXBContext jc = JAXBContext.newInstance(RetrieveDocumentSetResponseType.class);
                Unmarshaller m = jc.createUnmarshaller();
                return (AdhocQueryResponseType) m.unmarshal(new ByteArrayInputStream(aqr.getBytes(StandardCharsets.UTF_8)));
            } catch (JAXBException e) {
                LOG.error("" + e.getMessage());
            }
        }
        return null;
    }

    private String getAdhocQueryAsString(Object aqr) {
        try {
            JAXBContext jc = JAXBContext.newInstance("net.ihe.gazelle.xds");
            Marshaller m = jc.createMarshaller();
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
            m.setProperty("com.sun.xml.bind.namespacePrefixMapper", new XDSNamespacePrefixMapper());
            m.marshal(aqr, baos);
            return baos.toString(UTF_8);
        } catch (UnsupportedEncodingException e) {
            LOG.error("" + e.getMessage());
        } catch (JAXBException e) {
            LOG.error("" + e.getMessage());
        }
        return null;
    }

    static String getRetrieveDocumentSetResponseTypeAsString(Object aqr) {
        try {
            JAXBContext jc = JAXBContext.newInstance(RetrieveDocumentSetResponseType.class);
            Marshaller m = jc.createMarshaller();
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
            m.setProperty("com.sun.xml.bind.namespacePrefixMapper", new XDSNamespacePrefixMapper());
            m.marshal(aqr, baos);
            return baos.toString(UTF_8);
        } catch (UnsupportedEncodingException e) {
            LOG.error("" + e.getMessage());
        } catch (JAXBException e) {
            LOG.error("" + e.getMessage());
        }
        return null;
    }

//	public static void main(String[] args) throws Exception {
//		RetrieveDocumentSetRequestType req = new RetrieveDocumentSetRequestType();
//		req.getDocumentRequest().add(new DocumentRequestType());
//		req.getDocumentRequest().get(0).setDocumentUniqueId("2.16.840.1.113883.1.3");
//		req.getDocumentRequest().get(0).setRepositoryUniqueId("2.16.17.710.812.1000.990.1");
//		req.getDocumentRequest().get(0).setHomeCommunityId("urn:oid:2.16.17.710.812.1000.990.1");
//		req.getDocumentRequest().add(new DocumentRequestType());
//		req.getDocumentRequest().get(1).setDocumentUniqueId("1.3.6.1.4.1.12559.11.1.2.2.1.1.3.1324");
//		req.getDocumentRequest().get(1).setRepositoryUniqueId("2.16.17.710.812.1000.990.1");
//		req.getDocumentRequest().get(1).setHomeCommunityId("urn:oid:2.16.17.710.812.1000.990.1");
//		Pair<String, String> res = (new RespondingGatewayRetrievePortTypeClient()).send(req,
//				"http://jumbo-3.irisa.fr:9080/epsos/services/rg");
//		LOG.info("aaaa == " + res.getObject1());
//		LOG.info("bbbb = " + res.getObject2());
//		LOG.info("##############################");
//		RetrieveDocumentSetResponseType ret = MarshallRetrieveMTOM.transformMTOM2RetrieveDocumentResponse(
//				res.getObject2(), res.getObject1());
//		LOG.info(getRetrieveDocumentSetResponseTypeAsString(ret));
//	}

}
